#include "tof_hw.h"


sfr sbit TOF_ENABLE at GPIO_PIN1_bit;
sfr sbit TOF_DRDY at GPIO_PIN3_bit;

uint64_t milliseconds_counter;

void timer_setup()
{
  TIMER_CONTROL_0 = 2;
  TIMER_SELECT = 0;
  TIMER_PRESC_LS = 80;
  TIMER_PRESC_MS = 195;
  TIMER_WRITE_LS = 1;
  TIMER_WRITE_MS = 0;
  TIMER_CONTROL_3 = 0;
  TIMER_CONTROL_4 = 17;
  TIMER_CONTROL_2 = 16;
  TIMER_INT = 2;
  IRQ_CTRL.B31 = 0;
  TIMER_CONTROL_1 = 1;

}


void mcu_setup()
{

  GPIO_Digital_Output(&GPIO_PORT_00_07, _GPIO_PINMASK_1);
  GPIO_Digital_Input(&GPIO_PORT_00_07, _GPIO_PINMASK_3);

  TOF_ENABLE = 0;
  delay_ms(100);
  I2CM1_Init( _I2CM_SPEED_MODE_STANDARD, _I2CM_SWAP_DISABLE );
  delay_ms(200);
  tof_hal_init();
  TOF_ENABLE = 1;
  delay_ms(100);
  Uart1_Init(57600);
  delay_ms(200);
  Uart_Write_Text("Uart init\r\n");



}

uint8_t testread[3];
uint16_t model_id;
uint16_t range;

void main()
{
     char txt[10];


     mcu_setup();
     timer_setup();

     tof_init(true);
     tof_set_timeout(500);
     tof_start_continuous(0);
     Uart_Write_Text("TOF ready\r\n");


     while(1)
     {
        range = tof_read_range_continuous_millimeters();
        WordToStr(range, txt);
        Uart_Write_Text("Range: ");
        Uart_Write_Text(txt);
        Uart_Write_Text("\r\n");

        if (tof_timeout_occurred())
           Uart_Write_Text("TIMEOUT\r\n");

     }


}

void TimerInterrupt() iv IVT_TIMERS_IRQ
{
     if (TIMER_INT_A_bit)
     {
        TIMER_INT = (TIMER_INT & 0xAA) | (1 << 0);
        milliseconds_counter++;
     }

}